Subject: Re: [PATCH] archive: add test testing MIME for created archive through compression filter

From: Junio C Hamano <[email-masked]>
Date: Tue, 12 Oct 2021 12:15:39 -0700

Bagas Sanjaya <[email-masked]> writes:

> On 11/10/21 22.53, Junio C Hamano wrote:
>> I think a lot more portable and robust way to test the feature is to
>> configure git config tar.tar.test.command (or come up with a name for
>> a suffix to be used in the test), point it at a script created in this
>> test script and run git archive with output filename that would trigger
>> the command.  Then, arrange the test to notice if the "test" script was
>> called with expected command line arguments and standard input.
>> That way, you do not need to rely on prereqs and you do not have to
>> resort to un-portable use of the "file" command.  After all, you are
>> *not* testing if "bzip2 -c" the user happens to have on their $PATH
>> produces output their "find" recognises as bzip2 compressed.
>> 
>
> The intent of this test is to ensure `git archive -o
> something.tar.<format>` produces proper compressed tar archive that
> can be decompressed with the corresponding decompression tool (such as 
> gunzip for gz files), and not just with `tar xvf`.

Yes, that is why relying on "file -i" is not the right thing to do.

We'd want to use the matching decompressor, or better yet, trust
that the compressor-decompressor pair the system offers do work
correctly (after all, it's not our test suite's job to debug the
system software the tester uses) and validate that

 (1) the specified compressor is spawned with the right parameters
     taken from the configuration file, and that

 (2) the compressor is fed the correct input stream.

Using a script prepared by the test itself as the "compressor" would
be one good way to validate (1); it can record how it was invoked,
so that the test can check its correctness.  Using a reversible
transformation in the script as a fake compressor and comparing the
reversed output with the output without any compression filter, may
be one way to validate (2), like Peff mentioned.

But asking "file -i" validates neither.

The code that reads the configuration and spawns the compressor with
specified parameters may be broken and may not pass the right
parameters, or the archive stream may not be passed to the
compressor intact.  But the compressor may still produce a header
block that is looking correct enough for the "file" command to say
"ah, that uses X compressor", and the tests in the patch under
discussion does not even see if the payload was passed correctly
without corruption to the compressor at all.